unit UnitGraph;

interface

uses
   Windows, SysUtils, Graphics, Math, GDIPAPI, GDIPOBJ, Direct2D, D2D1,
   GIFImg,pngimage,jpeg, UnitFunc ;

type
   TWorkPolygonArea = record     // Ɨpb|Sp
      an : integer ;
      a  : array of TPointD ;
      pnts : array of TGPPointF ;
      pntsD: array of TD2DPoint2f;
   end;

   TGraphClass = class
   public
      { Public 錾 }
      DisplayMode : integer ;    // `惂[h 0:GDI 1:GDI+ 2:Direct2D
      constructor Create;
      destructor Free;
      procedure DataInit;
      procedure RefreshGDIplus ;
      procedure SetDisplayMode(m:integer);
      procedure PoArClear ;
      procedure PoArSet1(n:integer);
      procedure PoArSet2(n,pn:integer;wx,wy,md:double;pt:array of TPointD);
      procedure PoArSet3(n,pn:integer;wx,wy,md:double;pt:array of TPointD;t:TMatrix);
      procedure G_Start(C:TCanvas);
      procedure G_End ;
      procedure G_Cls(col:integer) ;
      procedure G_SetPen(col:integer) ;
      procedure G_SetWidth(wid:integer) ;
      procedure G_Line(x1,y1,x2,y2:integer) ;
      procedure G_Circle(x,y,r:integer) ;
      procedure G_CircleF(x,y,r:integer) ;
      procedure G_Polygon(n:integer) ;
      procedure G_PolygonA ; overload ;
      procedure G_PolygonA(rgb,alpha:integer) ; overload ;
      procedure G_PolygonA(rgb1,rgb2,alpha:integer;x1,y1,x2,y2:double) ; overload ;
      procedure G_PolygonA(rgb1,rgb2,alpha:integer;x1,y1,x2,y2,rx,ry:double) ; overload ;
      procedure G_PolygonA(fn:string) ; overload ;
      procedure G_Text1(at,x,y,h,w:integer;an,sl:double;fo,st:string);
      function  G_TextWidth(at,h,w:integer;f,s:string):integer;
      procedure G_Image(x,y,sx,sy,an:double;fn:string) ;
      procedure G_ImageSize(var h,w:integer;fn:string) ;
   private
      { Private 錾 }
      PoAr  : array of TWorkPolygonArea ;       // Ɨpb|Sp
      PoArN : Integer ;
      Ca: TCanvas ;
      gra : TGPGraphics;
      pen : TGPPen;
      br0 : TGPSolidBrush;
      path: TGPGraphicsPath;
      D2DCanvas : TDirect2DCanvas ;
      D2Dfa : ID2D1Factory ;
      D2Dss : ID2D1StrokeStyle ;
      D2Dbr : ID2D1Brush;
   end;

implementation

// 
constructor TGraphClass.Create;
begin
   DataInit ;
end;

// 
destructor TGraphClass.Free;
begin
   PoArClear ;
   Ca := nil;
   if (gra <> nil) then begin
      gra.Free;
      gra := nil;
   end;
   if (pen <> nil) then begin
      pen.Free;
      pen := nil;
   end;
   if (br0 <> nil) then begin
      br0.Free;
      br0 := nil;
   end;
   if (path<> nil) then begin
      path.Free;
      path := nil ;
   end;
   if (D2DCanvas <> nil) then begin
      D2DCanvas.Free;
      D2DCanvas := nil;
   end;
end;

// lZbg
procedure TGraphClass.DataInit;
begin
   DisplayMode := 0;
   PoAr  := nil ;
   PoArN := 0 ;
   Ca := nil;
   gra:= nil;
   pen:= nil;
   br0:= nil;
   path:= nil ;
   D2DCanvas := nil;
end;

// GDIGDI+𗘗pۂ̍Ō̃tbV
procedure TGraphClass.RefreshGDIplus ;
begin
   if (DisplayMode = 0) then begin
      // `̗h~
      gra.Free ;
      gra := nil ;
      gra := TGPGraphics.Create(Ca.Handle);
      gra.SetSmoothingMode(SmoothingModeHighSpeed);
      gra.SetPageUnit(UnitPixel);
   end;
end;

// `惂[hݒ
//    m : 0:GDI 1:GDI+ 2:Direct2D
//    Direct2Dg邩ǂ𔻒肵DisplayModeɓ
procedure TGraphClass.SetDisplayMode(m:integer);
begin
   if (m < 0)or(m > 2) then m:=0;
   if (m = 2) then
      if not(TDirect2DCanvas.Supported) then m:=0;
   DisplayMode := m ;
end;

// Ɨp|S̈
procedure TGraphClass.PoArClear ;
var
   i : integer ;
begin
   for i:=0 to PoArN-1 do begin
      PoAr[i].a      := nil;
      PoAr[i].pnts   := nil;
      PoAr[i].pntsD  := nil;
   end;
   PoAr  := nil ;
   PoArN := 0 ;
end;

// Ɨp|S̈̃m
//    n : _Q
procedure TGraphClass.PoArSet1(n:integer);
begin
   if (n <= 1) then n := 1;
   PoArN := n ;
   try
      SetLength(PoAr, PoArN);
   except
      PoAr  := nil ;
      PoArN := 0 ;
   end;
end;

// Ɨp|S̈ɓ_Qǉ
//    n : _Qԍ(0-)
procedure TGraphClass.PoArSet2(n,pn:integer;wx,wy,md:double;pt:array of TPointD);
var
   i : integer ;
   x,y : double ;
begin
   if (PoArN < (n+1))or(n < 0)or(pn < 2) then exit;
   PoAr[n].an := pn ;
   try
      SetLength(PoAr[n].a, PoAr[n].an);
      for i:=0 to pn-1 do begin
         x :=  (pt[i].x - wx)*md ;
         y := -(pt[i].y - wy)*md ;
         PoAr[n].a[i].x := Int(x * 1000000.0+0.5)/1000000.0;
         PoAr[n].a[i].y := Int(y * 1000000.0+0.5)/1000000.0;
      end;
   except
      PoAr[n].a  := nil ;
      PoAr[n].an := 0 ;
   end;
end;

// Ɨp|S̈ɓ_Qǉ
//    n : _Qԍ(0-)
procedure TGraphClass.PoArSet3(n,pn:integer;wx,wy,md:double;pt:array of TPointD;t:TMatrix);
var
   i : integer ;
   x,y : double ;
begin
   if (PoArN < (n+1))or(n < 0)or(pn < 2) then exit;
   PoAr[n].an := pn ;
   try
      SetLength(PoAr[n].a, PoAr[n].an);
      for i:=0 to pn-1 do begin
         MtxXY(x,y, pt[i].x,pt[i].y, t);
         x :=  (x - wx)*md ;
         y := -(y - wy)*md ;
         PoAr[n].a[i].x := Int(x * 1000000.0+0.5)/1000000.0;
         PoAr[n].a[i].y := Int(y * 1000000.0+0.5)/1000000.0;
      end;
   except
      PoAr[n].a  := nil ;
      PoAr[n].an := 0 ;
   end;
end;

// `Jn
//    C : `
//    `sŏɕKs
procedure TGraphClass.G_Start(C:TCanvas);
begin
   Ca := C ;
   case(DisplayMode)of
   0,1:begin     // GDI,GDI+
         with Ca do begin
            Pen.Color := clBlack;
            Pen.Width := 1;
            Pen.Style := psSolid;
         end;
         // GDI+
         gra := TGPGraphics.Create(Ca.Handle);
         gra.SetSmoothingMode(SmoothingModeHighSpeed);
         gra.SetPageUnit(UnitPixel);
         pen := TGPPen.Create(MakeColor(255, 0, 0, 0));
         pen.SetWidth(1.0);
         // [ۂݒ
         pen.SetDashStyle(DashStyleSolid);
         pen.SetStartCap(LineCapRound);
         pen.SetEndCap(LineCapRound);
         pen.SetLineJoin(LineJoinRound);
         // uV
         br0 :=TGPSolidBrush.Create(MakeColor(255, 0, 0, 0));
         // 
         gra.SetTextRenderingHint(TextRenderingHintSystemDefault);
       end;
   2: begin     // Direct2D
         D2DCanvas := TDirect2DCanvas.Create(Ca, Ca.ClipRect);
         with D2DCanvas do begin
            BeginDraw;
            RenderTarget.SetAntialiasMode(D2D1_ANTIALIAS_MODE_ALIASED); // A`GCAX
            RenderTarget.SetTextAntialiasMode(D2D1_TEXT_ANTIALIAS_MODE_GRAYSCALE);
            Pen.Color := clBlack;
            Pen.Width := 1;
            Pen.Style := psSolid ;
            // [ۂݒ  `RenderTargetɑ΂čs
            RenderTarget.GetFactory(D2Dfa);
            D2Dfa.CreateStrokeStyle(
               D2D1StrokeStyleProperties(D2D1_CAP_STYLE_ROUND,D2D1_CAP_STYLE_ROUND,D2D1_CAP_STYLE_ROUND,
               D2D1_LINE_JOIN_ROUND,10,D2D1_DASH_STYLE_SOLID,0),nil,0,D2Dss);
            D2Dbr := CreateBrush(Pen.Color);
         end;
      end;
   end;
end;

// `I
//    `I鎞ɕKs
procedure TGraphClass.G_End ;
begin
   // Ca := nil;
   case(DisplayMode)of
   0,1:begin     // GDI+
         pen.Free;   pen := nil;
         br0.Free;   br0 := nil;
         gra.Free;   gra := nil;
         path.Free;  path:= nil;
      end;
   2: begin     // Direct2D
         with D2DCanvas do begin
            EndDraw;
            Free;
         end;
         D2DCanvas := nil;
      end;
   end;
end;

// ʃNA
//    col : wiF(RGB)
procedure TGraphClass.G_Cls(col:integer) ;
begin
   case(DisplayMode)of
   0: begin     // GDI
         with Ca do begin
            Brush.Color := col ;
            Brush.Style := bsSolid ;
            Fillrect(ca.ClipRect);
         end;
      end;
   1: begin     // GDI+
         gra.Clear(ColorRefToARGB(col)) ;
      end;
   2: begin     // Direct2D
         with D2DCanvas do begin
            RenderTarget.Clear(D2D1ColorF(col));
         end;
      end;
   end;
end;

// yݒ
//    col : \F(RGB)
procedure TGraphClass.G_SetPen(col:integer) ;
begin
   case(DisplayMode)of
   0: begin     // GDI
         with Ca do begin
            Pen.Color := col ;
            Brush.Color := col ;
         end;
      end;
   1: begin     // GDI+
         pen.SetColor(ColorRefToARGB(col)) ;
         br0.SetColor(ColorRefToARGB(col)) ;
      end;
   2: begin     // Direct2D
         with D2DCanvas do begin
            Pen.Color := col ;
            D2Dbr := CreateBrush(Pen.Color);
         end;
      end;
   end;
end;

// yݒ
//    wid : 
procedure TGraphClass.G_SetWidth(wid:integer) ;
begin
   case(DisplayMode)of
   0: begin     // GDI
         with Ca do begin
            Pen.Width := wid ;
         end;
      end;
   1: begin     // GDI+
         pen.SetWidth(wid) ;
      end;
   2: begin     // Direct2D
         with D2DCanvas do begin
            Pen.Width := wid ;
         end;
      end;
   end;
end;

// `
//    x1,y1 : n_
//    x2,y2 : I_
procedure TGraphClass.G_Line(x1,y1,x2,y2:integer) ;
begin
   case(DisplayMode)of
   0: begin     // GDI
         with Ca do begin
            MoveTo(x1,y1);
            LineTo(x2,y2);
         end;
      end;
   1: begin     // GDI+
         gra.DrawLine(pen, x1,y1, x2,y2);
      end;
   2: begin     // Direct2D
         with D2DCanvas do begin
            RenderTarget.DrawLine(D2D1PointF(x1,y1),D2D1PointF(x2,y2),D2Dbr,Pen.Width,D2Dss);
         end;
      end;
   end;
end;

// ~`
//    x,y : S_
//    r   : a
procedure TGraphClass.G_Circle(x,y,r:integer) ;
begin
   if (r < 1) then r := 1 ;
   case(DisplayMode)of
   0: begin     // GDI
         with Ca do begin
            Brush.Style := bsClear ;
            Ellipse(x-r,y-r, x+r,y+r);
         end;
      end;
   1: begin     // GDI+
         gra.DrawEllipse(pen, x-r,y-r, r+r,r+r);
      end;
   2: begin     // Direct2D
         with D2DCanvas do begin
            RenderTarget.DrawEllipse(D2D1Ellipse(D2D1PointF(x,y),r,r),D2Dbr,Pen.Width,D2Dss);
         end;
      end;
   end;
end;

// hׂ~`
//    x,y : S_
//    r   : a
procedure TGraphClass.G_CircleF(x,y,r:integer) ;
begin
   if (r < 1) then r := 1 ;
   case(DisplayMode)of
   0: begin     // GDI
         with Ca do begin
            Brush.Style := bsSolid ;
            Brush.Color := Pen.Color ;
            Ellipse(x-r,y-r, x+r,y+r);
            Brush.Style := bsClear ;
         end;
      end;
   1: begin     // GDI+
         gra.FillEllipse(br0, x-r,y-r, r+r,r+r);
      end;
   2: begin     // Direct2D
         with D2DCanvas do begin
            RenderTarget.FillEllipse(D2D1Ellipse(D2D1PointF(x,y),r,r),D2Dbr);
         end;
      end;
   end;
end;

// |S`
procedure TGraphClass.G_Polygon(n:integer) ;
var
   i : integer ;
   geo: ID2D1PathGeometry;
   aSink: ID2D1GeometrySink;
begin
   if (n < 0)or((n+1) > PoArN) then exit ;
   case(DisplayMode)of
   0,1:begin     // GDIGDI+AGDI+
         if (DisplayMode = 0) then begin
            br0.SetColor(ColorRefToARGB(Ca.Pen.Color)) ;
         end;
         with PoAr[n] do begin
            try
               SetLength(pnts, an);
               for i:=0 to an-1 do begin
                  pnts[i].X := a[i].x ;
                  pnts[i].Y := a[i].y ;
               end;
               gra.FillPolygon(br0, PGPPointF(@pnts[0]), an) ;
               //gra.DrawPolygon(pen, PGPPointF(@pnts[0]), an) ;
            except
               ;
            end;
            pnts := nil ;
         end;

         RefreshGDIplus;   // GDIGDI+𗘗pۂ̍Ō̃tbV
      end;
   2: begin     // Direct2D
         D2DFactory.CreatePathGeometry(geo);
         geo.Open(aSink);
         with PoAr[n] do begin
            pntsD := nil ;
            try
               aSink.SetFillMode(D2D1_FILL_MODE_WINDING);
               aSink.BeginFigure(
                  D2D1PointF(a[0].x,a[0].y),
                  D2D1_FIGURE_BEGIN_FILLED
               );
               SetLength(pntsD, an);
               for i:=0 to an-1 do begin
                  pntsD[i].X := a[i].x ;
                  pntsD[i].Y := a[i].y ;
               end;
               aSink.AddLines(@pntsD[0], Length(pntsD));
               aSink.EndFigure(D2D1_FIGURE_END_CLOSED);
               aSink.Close;
            except
               aSink.Close;
            end;
            pntsD := nil ;
         end;
         with D2DCanvas do begin
            RenderTarget.FillGeometry(geo,D2Dbr);
            // RenderTarget.DrawGeometry(geo,D2Dbr,Pen.Width,D2Dss);
         end;
      end;
   end;
end;

// |S`
procedure TGraphClass.G_PolygonA ;
var
   n,i : integer ;
   geo: ID2D1PathGeometry;
   aSink: ID2D1GeometrySink;
begin
   if (PoArN <= 0) then exit ;
   case(DisplayMode)of
   0,1:begin     // GDIGDI+AGDI+
         if (DisplayMode = 0) then begin
            br0.SetColor(ColorRefToARGB(Ca.Pen.Color)) ;
         end;
         if (path <> nil) then begin
            path.Free ;
            path := nil;
         end;
         path := TGPGraphicsPath.Create;
         path.StartFigure;

         for n:=0 to PoArN-1 do begin
            with PoAr[n] do begin
               try
                  SetLength(pnts, an);
                  for i:=0 to an-1 do begin
                     pnts[i].X := a[i].x ;
                     pnts[i].Y := a[i].y ;
                  end;
                  path.AddPolygon(PGPPointF(@pnts[0]), an);
               except
                  ;
               end;
               pnts := nil ;
            end;
         end;

         path.CloseFigure;
         gra.FillPath(br0, path);
         path.Free;
         path := nil;

         RefreshGDIplus;   // GDIGDI+𗘗pۂ̍Ō̃tbV
      end;
   2: begin     // Direct2D
         D2DFactory.CreatePathGeometry(geo);
         geo.Open(aSink);
         for n:=0 to PoArN-1 do begin
            with PoAr[n] do begin
               pntsD := nil ;
               try
                  aSink.SetFillMode(D2D1_FILL_MODE_ALTERNATE);
                  aSink.BeginFigure(
                     D2D1PointF(a[0].x,a[0].y),
                     D2D1_FIGURE_BEGIN_FILLED
                  );
                  SetLength(pntsD, an);
                  for i:=0 to an-1 do begin
                     pntsD[i].X := a[i].x ;
                     pntsD[i].Y := a[i].y ;
                  end;
                  aSink.AddLines(@pntsD[0], Length(pntsD));
                  aSink.EndFigure(D2D1_FIGURE_END_CLOSED);
               except
                  ;
               end;
               pntsD := nil ;
            end;
         end;
         aSink.Close;
         with D2DCanvas do begin
            RenderTarget.FillGeometry(geo,D2Dbr);
            // RenderTarget.DrawGeometry(geo,D2Dbr,Pen.Width,D2Dss);
         end;
      end;
   end;
end;

// |S`   ߓh
procedure TGraphClass.G_PolygonA(rgb,alpha:integer) ;
var
   n,i : integer ;
   geo: ID2D1PathGeometry;
   aSink: ID2D1GeometrySink;
begin
   if (PoArN <= 0) then exit ;
   case(DisplayMode)of
   0,1:begin     // GDIGDI+AGDI+
         if (path <> nil) then begin
            path.Free ;
            path := nil;
         end;
         path := TGPGraphicsPath.Create;
         path.StartFigure;

         for n:=0 to PoArN-1 do begin
            with PoAr[n] do begin
               try
                  SetLength(pnts, an);
                  for i:=0 to an-1 do begin
                     pnts[i].X := a[i].x ;
                     pnts[i].Y := a[i].y ;
                  end;
                  path.AddPolygon(PGPPointF(@pnts[0]), an);
               except
                  ;
               end;
               pnts := nil ;
            end;
         end;

         path.CloseFigure;
         br0.SetColor(MakeColor(alpha, GetRValue(rgb), GetGValue(rgb), GetBValue(rgb)));
         gra.FillPath(br0, path);
         path.Free;
         path := nil;
         br0.SetColor(ColorRefToARGB(rgb)) ; // ꉞߖɖ߂܂

         RefreshGDIplus;   // GDIGDI+𗘗pۂ̍Ō̃tbV
      end;
   2: begin     // Direct2D
         D2DFactory.CreatePathGeometry(geo);
         geo.Open(aSink);
         for n:=0 to PoArN-1 do begin
            with PoAr[n] do begin
               pntsD := nil ;
               try
                  aSink.SetFillMode(D2D1_FILL_MODE_ALTERNATE);
                  aSink.BeginFigure(
                     D2D1PointF(a[0].x,a[0].y),
                     D2D1_FIGURE_BEGIN_FILLED
                  );
                  SetLength(pntsD, an);
                  for i:=0 to an-1 do begin
                     pntsD[i].X := a[i].x ;
                     pntsD[i].Y := a[i].y ;
                  end;
                  aSink.AddLines(@pntsD[0], Length(pntsD));
                  aSink.EndFigure(D2D1_FIGURE_END_CLOSED);
               except
                  ;
               end;
               pntsD := nil ;
            end;
         end;
         aSink.Close;
         with D2DCanvas do begin
            D2Dbr := CreateBrush(rgb);
            D2Dbr.SetOpacity(alpha/255);
            RenderTarget.FillGeometry(geo,D2Dbr);
            // RenderTarget.DrawGeometry(geo,D2Dbr,Pen.Width,D2Dss);

            D2Dbr.SetOpacity(1.0);  // ꉞߖɖ߂܂
         end;
      end;
   end;
end;

// |S`   `Of[Vh
procedure TGraphClass.G_PolygonA(rgb1,rgb2,alpha:integer;x1,y1,x2,y2:double) ;
var
   n,i : integer ;
   geo: ID2D1PathGeometry;
   aSink: ID2D1GeometrySink;
   br : TGPLinearGradientBrush;
begin
   if (PoArN <= 0) then exit ;
   case(DisplayMode)of
   0,1:begin     // GDIGDI+AGDI+
         if (path <> nil) then begin
            path.Free ;
            path := nil;
         end;
         path := TGPGraphicsPath.Create;
         path.StartFigure;

         for n:=0 to PoArN-1 do begin
            with PoAr[n] do begin
               try
                  SetLength(pnts, an);
                  for i:=0 to an-1 do begin
                     pnts[i].X := a[i].x ;
                     pnts[i].Y := a[i].y ;
                  end;
                  path.AddPolygon(PGPPointF(@pnts[0]), an);
               except
                  ;
               end;
               pnts := nil ;
            end;
         end;

         path.CloseFigure;
         br := TGPLinearGradientBrush.Create(
               MakePoint(x1,y1), MakePoint(x2,y2),
               MakeColor(alpha, GetRValue(rgb1), GetGValue(rgb1), GetBValue(rgb1)),
               MakeColor(alpha, GetRValue(rgb2), GetGValue(rgb2), GetBValue(rgb2)));
         gra.FillPath(br, path);
         br.Free;
         path.Free;
         path := nil;

         RefreshGDIplus;   // GDIGDI+𗘗pۂ̍Ō̃tbV
      end;
   2: begin     // Direct2D
         D2DFactory.CreatePathGeometry(geo);
         geo.Open(aSink);
         for n:=0 to PoArN-1 do begin
            with PoAr[n] do begin
               pntsD := nil ;
               try
                  aSink.SetFillMode(D2D1_FILL_MODE_ALTERNATE);
                  aSink.BeginFigure(
                     D2D1PointF(a[0].x,a[0].y),
                     D2D1_FIGURE_BEGIN_FILLED
                  );
                  SetLength(pntsD, an);
                  for i:=0 to an-1 do begin
                     pntsD[i].X := a[i].x ;
                     pntsD[i].Y := a[i].y ;
                  end;
                  aSink.AddLines(@pntsD[0], Length(pntsD));
                  aSink.EndFigure(D2D1_FIGURE_END_CLOSED);
               except
                  ;
               end;
               pntsD := nil ;
            end;
         end;
         aSink.Close;
         with D2DCanvas do begin
            D2Dbr := CreateBrush([rgb1,rgb2],D2D1PointF(x1,y1),D2D1PointF(x2,y2));
            D2Dbr.SetOpacity(alpha/255);
            RenderTarget.FillGeometry(geo,D2Dbr);
            // RenderTarget.DrawGeometry(geo,D2Dbr,Pen.Width,D2Dss);

            D2Dbr.SetOpacity(1.0);  // ꉞߖɖ߂܂
         end;
      end;
   end;
end;

// |S`   ~`Of[Vh
procedure TGraphClass.G_PolygonA(rgb1,rgb2,alpha:integer;x1,y1,x2,y2,rx,ry:double) ;
var
   n,i : integer ;
   geo: ID2D1PathGeometry;
   aSink: ID2D1GeometrySink;
   br : TGPPathGradientBrush;
   Gcols : array of Cardinal;
   GcolN : integer ;
begin
   if (PoArN <= 0) then exit ;
   case(DisplayMode)of
   0,1:begin     // GDIGDI+AGDI+
         if (path <> nil) then begin
            path.Free ;
            path := nil;
         end;
         path := TGPGraphicsPath.Create;
         path.StartFigure;
         path.AddEllipse(x1-rx,y1-ry, rx+rx,ry+ry);
         path.CloseFigure;
         br := TGPPathGradientBrush.Create(path);
         br.SetCenterPoint(MakePoint(x2, y2));
         br.SetCenterColor(MakeColor(alpha, GetRValue(rgb1), GetGValue(rgb1), GetBValue(rgb1)));
         GcolN := 1;
         SetLength(Gcols, GcolN);
         Gcols[0] := MakeColor(alpha, GetRValue(rgb2), GetGValue(rgb2), GetBValue(rgb2));
         br.SetSurroundColors(@Gcols[0], GcolN);
         Gcols := nil ;
         path.Free ;
         path := nil ;

         path := TGPGraphicsPath.Create;
         path.StartFigure;

         for n:=0 to PoArN-1 do begin
            with PoAr[n] do begin
               try
                  SetLength(pnts, an);
                  for i:=0 to an-1 do begin
                     pnts[i].X := a[i].x ;
                     pnts[i].Y := a[i].y ;
                  end;
                  path.AddPolygon(PGPPointF(@pnts[0]), an);
               except
                  ;
               end;
               pnts := nil ;
            end;
         end;

         path.CloseFigure;
         gra.FillPath(br, path);
         br.Free;
         path.Free;
         path := nil;

         RefreshGDIplus;   // GDIGDI+𗘗pۂ̍Ō̃tbV
      end;
   2: begin     // Direct2D
         D2DFactory.CreatePathGeometry(geo);
         geo.Open(aSink);
         for n:=0 to PoArN-1 do begin
            with PoAr[n] do begin
               pntsD := nil ;
               try
                  aSink.SetFillMode(D2D1_FILL_MODE_ALTERNATE);
                  aSink.BeginFigure(
                     D2D1PointF(a[0].x,a[0].y),
                     D2D1_FIGURE_BEGIN_FILLED
                  );
                  SetLength(pntsD, an);
                  for i:=0 to an-1 do begin
                     pntsD[i].X := a[i].x ;
                     pntsD[i].Y := a[i].y ;
                  end;
                  aSink.AddLines(@pntsD[0], Length(pntsD));
                  aSink.EndFigure(D2D1_FIGURE_END_CLOSED);
               except
                  ;
               end;
               pntsD := nil ;
            end;
         end;
         aSink.Close;
         with D2DCanvas do begin
            D2Dbr := CreateBrush([rgb1,rgb2],D2D1PointF(x1,y1),D2D1PointF(x2-x1,y2-y1),rx,ry);
            D2Dbr.SetOpacity(alpha/255);
            RenderTarget.FillGeometry(geo,D2Dbr);
            // RenderTarget.DrawGeometry(geo,D2Dbr,Pen.Width,D2Dss);

            D2Dbr.SetOpacity(1.0);  // ꉞߖɖ߂܂
         end;
      end;
   end;
end;

// |S`   摜h
procedure TGraphClass.G_PolygonA(fn:string) ;
var
   n,i : integer ;
   geo: ID2D1PathGeometry;
   aSink: ID2D1GeometrySink;
   br : TGPTextureBrush;
   im : TGPImage;
   pc : TPicture ;
   bm : TBitmap ;
begin
   if (PoArN <= 0) then exit ;
   case(DisplayMode)of
   0,1:begin     // GDIGDI+AGDI+
         if (path <> nil) then begin
            path.Free ;
            path := nil;
         end;
         path := TGPGraphicsPath.Create;
         path.StartFigure;

         for n:=0 to PoArN-1 do begin
            with PoAr[n] do begin
               try
                  SetLength(pnts, an);
                  for i:=0 to an-1 do begin
                     pnts[i].X := a[i].x ;
                     pnts[i].Y := a[i].y ;
                  end;
                  path.AddPolygon(PGPPointF(@pnts[0]), an);
               except
                  ;
               end;
               pnts := nil ;
            end;
         end;

         path.CloseFigure;

         im := nil ;
         br := nil ;
         try
            im := TGPImage.Create(fn);
            br := TGPTextureBrush.Create(im);
            im.Free ;
            gra.FillPath(br, path);
            br.Free ;
         except
            if (im <> nil) then im.Free ;
            if (br <> nil) then br.Free ;
         end;

         path.Free;
         path := nil;

         RefreshGDIplus;   // GDIGDI+𗘗pۂ̍Ō̃tbV
      end;
   2: begin     // Direct2D
         D2DFactory.CreatePathGeometry(geo);
         geo.Open(aSink);
         for n:=0 to PoArN-1 do begin
            with PoAr[n] do begin
               pntsD := nil ;
               try
                  aSink.SetFillMode(D2D1_FILL_MODE_ALTERNATE);
                  aSink.BeginFigure(
                     D2D1PointF(a[0].x,a[0].y),
                     D2D1_FIGURE_BEGIN_FILLED
                  );
                  SetLength(pntsD, an);
                  for i:=0 to an-1 do begin
                     pntsD[i].X := a[i].x ;
                     pntsD[i].Y := a[i].y ;
                  end;
                  aSink.AddLines(@pntsD[0], Length(pntsD));
                  aSink.EndFigure(D2D1_FIGURE_END_CLOSED);
               except
                  ;
               end;
               pntsD := nil ;
            end;
         end;
         aSink.Close;
         with D2DCanvas do begin
            pc := nil ;
            bm := nil ;
            try
               pc := TPicture.Create ;
               pc.LoadFromFile(fn) ;
               bm := TBitmap.Create ;
               bm.Width := pc.Width;
               bm.Height:= pc.Height;
               bm.Canvas.CopyMode := cmSrcCopy;
               bm.Canvas.Draw(0,0,pc.Graphic);
               pc.Free ;
               D2Dbr := CreateBrush(bm);
               bm.Free ;
            except
               if (pc <> nil) then pc.Free ;
               if (bm <> nil) then bm.Free ;
            end;
            RenderTarget.FillGeometry(geo,D2Dbr);
            // RenderTarget.DrawGeometry(geo,D2Dbr,Pen.Width,D2Dss);
         end;
      end;
   end;
end;

// `
//    at :   +1: +2:Α +4: +8:
//    x,y: ʒui_j
//    h,w: E
//    an : px[]
//    sl : Xgpx[] GDIł͖
//    fo : tHg
//    st : 
//    GDI+ADirect2D͏cptHg(@`)͎gps\Ȃ̂Œ
procedure TGraphClass.G_Text1(at,x,y,h,w:integer;an,sl:double;fo,st:string);
var
   LogFont : TLogFont ;
   lf : HFONT ;
   ff : TGPFontFamily;
   fon: TGPFont;
   m  : TGPMatrix ;
   xy : double ;
   t : D2D_MATRIX_3X2_F ;
   mt,mt1 : TMatrix ;
begin
   if (w < 2) then w := 2 ;
   if (h < 2) then h := 2 ;
   xy := w/h;
   case(DisplayMode)of
   0: begin     // GDI
         with LogFont do begin
            lfHeight       := h ;               // 
            lfWidth        := w div 2 ;         // 
            lfEscapement   := Round(an*10);     // ]px[] 10{l
            lfOrientation  := Round(an*10);     // lfEscapementƓl
            lfWeight       := FW_NORMAL ;       // w ʏ FW_NORMAL
            lfItalic       := 0 ;               // Α̎w L=1 =0
            lfUnderline    := 0 ;               // w L=1 =0
            lfStrikeOut    := 0 ;               // w L=1 =0
            if ((at and 1) > 0) then lfWeight := FW_BOLD ;
            if ((at and 2) > 0) then lfItalic := 1 ;
            if ((at and 4) > 0) then lfUnderline := 1 ;
            if ((at and 8) > 0) then lfStrikeOut := 1 ;
            lfCharSet      := DEFAULT_CHARSET ;
            lfOutPrecision := OUT_DEFAULT_PRECIS ;
            lfClipPrecision:= CLIP_DEFAULT_PRECIS ;
            lfQuality      := DEFAULT_QUALITY ;
            lfPitchAndFamily  := DEFAULT_PITCH ;
            StrPCopy(lfFaceName ,fo);
         end;
         lf := CreateFontIndirect(LogFont);
         with Ca do begin
            Font.Handle := lf ;
            Font.Color  := Pen.Color ;
            Brush.Style := bsClear ;
            TextOut(x,y,st);
         end;
         DeleteObject(lf);
      end;
   1: begin     // GDI+    GDI,Direct2DƈʒuE傫ȂׁAڕʂŔĂ܂
         ff := nil;
         try
            ff := TGPFontFamily.Create(fo);
            fon:= nil;
            try
               fon:= TGPFont.Create(ff, h, at, UnitPixel);
               MtxMove(mt, -0.17/xy*w,0.0);  // ڕʔ
               MtxScale(mt1, xy,1.0);
               mt := MtxMult(mt, mt1);
               MtxSlant(mt1, -Tan(sl/180.0*Pi),0.0);
               mt := MtxMult(mt, mt1);
               MtxMove(mt1, h*Tan(sl/180.0*Pi),0.0);
               mt := MtxMult(mt, mt1);
               MtxRotD(mt1, -an);
               mt := MtxMult(mt, mt1);
               MtxMove(mt1, x,y);
               mt := MtxMult(mt, mt1);
               m := TGPMatrix.Create(mt.t11,mt.t12, mt.t21,mt.t22, mt.t31, mt.t32);
               gra.SetTransform(m);
               m.Free ;
               gra.DrawString(st,-1,fon,MakePoint(0.0,0.0),br0);
               gra.ResetTransform;
            except
               ;
            end;
            if (fon <> nil) then fon.Free;
         except
            ;
         end;
         if (ff <> nil) then ff.Free;
      end;
   2: begin     // Direct2D
         with D2DCanvas do begin
            MtxScale(mt, xy,1.0);
            MtxSlant(mt1, -Tan(sl/180.0*Pi),0.0);
            mt := MtxMult(mt, mt1);
            MtxMove(mt1, h*Tan(sl/180.0*Pi),0.0);
            mt := MtxMult(mt, mt1);
            MtxRotD(mt1, -an);
            mt := MtxMult(mt, mt1);
            MtxMove(mt1, x,y);
            mt := MtxMult(mt, mt1);
            t._11 := mt.t11 ;
            t._12 := mt.t12 ;
            t._21 := mt.t21 ;
            t._22 := mt.t22 ;
            t._31 := mt.t31 ;
            t._32 := mt.t32 ;
            RenderTarget.SetTransform(t);

            Brush.Style := bsClear ;
            Font.Brush.Handle := D2Dbr ;
            Font.Name   := fo ;
            Font.Style  := [] ;
            if ((at and 1) > 0) then Font.Style := Font.Style + [fsBold] ;
            if ((at and 2) > 0) then Font.Style := Font.Style + [fsItalic] ;
            if ((at and 4) > 0) then Font.Style := Font.Style + [fsUnderline] ;
            if ((at and 8) > 0) then Font.Style := Font.Style + [fsStrikeOut] ;
            Font.Height := - h ;
            TextOut(0,0,st);

            t._11 := 1.0 ;
            t._12 := 0.0 ;
            t._21 := 0.0 ;
            t._22 := 1.0 ;
            t._31 := 0.0 ;
            t._32 := 0.0 ;
            RenderTarget.SetTransform(t);
         end;
      end;
   end;
end;

// ʂɕ\镶擾
//    h : 
//    w : Sp
//    f : tHg
//    s : e
// (ret)  
function TGraphClass.G_TextWidth(at,h,w:integer;f,s:string):integer;
var
   LogFont : TLogFont ;
   lf : HFONT ;
begin
   with LogFont do begin
      lfHeight       := h ;         // 
      lfWidth        := w div 2 ;   // 
      lfEscapement   := 0 ;         // ]px[] 10{l
      lfOrientation  := 0 ;         // lfEscapementƓl
      lfWeight       := FW_NORMAL;  // w ʏ FW_NORMAL
      lfItalic       := 0 ;         // Α̎w L=1 =0
      lfUnderline    := 0 ;         // w L=1 =0
      lfStrikeOut    := 0 ;         // w L=1 =0
      if ((at and 1) > 0) then lfWeight := FW_BOLD ;
      if ((at and 2) > 0) then lfItalic := 1 ;
      if ((at and 4) > 0) then lfUnderline := 1 ;
      if ((at and 8) > 0) then lfStrikeOut := 1 ;
      lfCharSet      := DEFAULT_CHARSET ;
      lfOutPrecision := OUT_DEFAULT_PRECIS ;
      lfClipPrecision:= CLIP_DEFAULT_PRECIS ;
      lfQuality      := DEFAULT_QUALITY ;
      lfPitchAndFamily  := DEFAULT_PITCH ;
      StrPCopy(lfFaceName ,f);
   end;
   lf := CreateFontIndirect(LogFont);
   with Ca do begin
      Font.Handle := lf ;
      Result := TextWidth(s);
   end;
   DeleteObject(lf);
end;

// 摜`
//    x,y : `ʒui_j
//    sx,sy : {Ec{
//    an  ; ]px[]
//    fn  : t@C
procedure TGraphClass.G_Image(x,y,sx,sy,an:double;fn:string) ;
var
   dx,dy : double ;
   im1 : TGPImage;
   mt1 : TGPMatrix ;
   im2 : TPicture ;
   mt2 : D2D_MATRIX_3X2_F ;
begin
   case(DisplayMode)of
   0,1:begin      // GDI,GDI{
         im1 := nil ;
         mt1 := nil ;
         try
            im1 := TGPImage.Create(fn);
            dx  := sy*im1.GetHeight*Cos(-(an+90.0)/180.0*Pi);
            dy  := sy*im1.GetHeight*Sin(-(an+90.0)/180.0*Pi);
            mt1 := TGPMatrix.Create ;
            mt1.Translate(x+dx,y+dy);
            mt1.Rotate(-an);
            mt1.Scale(sx,sy);
            gra.SetTransform(mt1);
            mt1.Free ;
            gra.DrawImage(im1,0.0,0.0);
            im1.Free ;
         except
            if (im1 <> nil) then im1.Free ;
            if (mt1 <> nil) then mt1.Free ;
         end;
         gra.ResetTransform ;

         RefreshGDIplus;   // GDIGDI+𗘗pۂ̍Ō̃tbV
      end;
   2: begin       // Direct2D
         with D2DCanvas do begin
            im2 := nil ;
            try
               im2 := TPicture.Create ;
               im2.LoadFromFile(fn) ;
               dx  := sy*im2.Height*Cos(-(an+90.0)/180.0*Pi);
               dy  := sy*im2.Height*Sin(-(an+90.0)/180.0*Pi);
               mt2._11 := sx*Cos(-an/180.0*Pi) ;
               mt2._12 := sx*Sin(-an/180.0*Pi) ;
               mt2._21 :=-sy*Sin(-an/180.0*Pi) ;
               mt2._22 := sy*Cos(-an/180.0*Pi) ;
               mt2._31 := x+dx ;
               mt2._32 := y+dy ;
               RenderTarget.SetTransform(mt2);
               Draw(0,0,im2.Graphic);
               im2.Free ;
            except
               if (im2 <> nil) then im2.Free ;
            end;
            mt2._11 := 1.0 ;
            mt2._12 := 0.0 ;
            mt2._21 := 0.0 ;
            mt2._22 := 1.0 ;
            mt2._31 := 0.0 ;
            mt2._32 := 0.0 ;
            RenderTarget.SetTransform(mt2);
         end;
      end;
   end;
end;

// 摜̑傫擾
//    h,w : 摜̍E
//    fn  : t@C
procedure TGraphClass.G_ImageSize(var h,w:integer;fn:string) ;
var
   im1 : TGPImage;
   im2 : TPicture ;
begin
   h := 0 ;
   w := 0 ;
   case(DisplayMode)of
   0,1:begin      // GDI,GDI{
         im1 := nil ;
         try
            im1 := TGPImage.Create(fn);
            h   := im1.GetHeight ;
            w   := im1.GetWidth ;
            im1.Free ;
         except
            if (im1 <> nil) then im1.Free ;
         end;
      end;
   2: begin       // Direct2D
         im2 := nil ;
         try
            im2 := TPicture.Create ;
            im2.LoadFromFile(fn) ;
            h   := im2.Height ;
            w   := im2.Width ;
            im2.Free ;
         except
            if (im2 <> nil) then im2.Free ;
         end;
      end;
   end;
end;

end.
